(require (lib "graphics.ss" "graphics"))

(define koch-curve
  (lambda (pos1 pos2 level line-drawer)        
    (cond ((= 0 level) (line-drawer pos1 pos2))
          (else
           (let* ((dx (/ (- (posn-x pos2) (posn-x pos1)) 3))
                  (dy (/ (- (posn-y pos2) (posn-y pos1)) 3))
                  (pos3 (make-posn (+ (posn-x pos1) dx) (+ (posn-y pos1) dy)))
                  (pos4 (make-posn (+ (posn-x pos3) dx) (+ (posn-y pos3) dy)))
                  (x-mid (/ (+ (posn-x pos2) (posn-x pos1)) 2))
                  (y-mid (/ (+ (posn-y pos2) (posn-y pos1)) 2))                  
                  (pos5 (make-posn (+ x-mid (* .866 dy)) (- y-mid (* .866 dx)))))
             (koch-curve pos1 pos3 (- level 1) line-drawer)
             (koch-curve pos3 pos5 (- level 1) line-drawer)
             (koch-curve pos5 pos4 (- level 1) line-drawer)
             (koch-curve pos4 pos2 (- level 1) line-drawer))))))

(open-graphics)
(define my-viewport (open-viewport "Koch Curve" 400 400))
(define my-line-drawer (draw-line my-viewport))
(let ((pos1 (make-posn 0 0))
      (pos2 (make-posn 400 400)))
  (koch-curve pos1 pos2 6 my-line-drawer))